## ntv2-dmo 16.2.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ntv2)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

# AJA includes
include(AJAHelpers)
include(AJABuildOptions)
include(AJACommonDefines)
include(AJACommonFlags)
include(AJACommonPaths)
include(AJACommonVars)
include(AJAVersionConfig)
# CMake includes
include(GNUInstallDirs)

aja_message(STATUS "Platform: ${CMAKE_SYSTEM_NAME}")
aja_message(STATUS "Arch: ${CMAKE_HOST_SYSTEM_PROCESSOR}")
aja_message(STATUS "Compiler: ${CMAKE_CXX_COMPILER_ID}")
aja_message(STATUS "Install Prefix: ${CMAKE_INSTALL_PREFIX}")
if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
    aja_message(STATUS "Windows API Version: ${CMAKE_SYSTEM_VERSION}")
    string(REPLACE "." ";" AJA_WIN_API_VER "${CMAKE_SYSTEM_VERSION}")
    list(GET AJA_WIN_API_VER 0 AJA_WIN_API_VER_MAJOR)
    list(GET AJA_WIN_API_VER 1 AJA_WIN_API_VER_MINOR)
    list(GET AJA_WIN_API_VER 2 AJA_WIN_API_VER_BUILD)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    aja_message(STATUS "macOS Architectures: ${CMAKE_OSX_ARCHITECTURES}")
    aja_message(STATUS "macOS Deployment Target: ${CMAKE_OSX_DEPLOYMENT_TARGET}")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
else()
    aja_message(FATAL_ERROR "Unsupported platform: ${CMAKE_SYSTEM_NAME}")
endif()

# Add NTV2 sub-directories to CMake build config
if (AJA_BUILD_APPS AND EXISTS ${AJA_APPS_ROOT})
    aja_message(STATUS "adding ajaapps...")
    add_subdirectory(ajaapps)
endif()
if (AJA_BUILD_DRIVER AND EXISTS ${AJA_DRIVER_ROOT})
    aja_message(STATUS "adding ajadriver...")
    add_subdirectory(ajadriver)
endif()
if (AJA_BUILD_LIBS AND EXISTS ${AJA_LIBRARIES_ROOT})
    aja_message(STATUS "adding ajalibraries...")
    add_subdirectory(ajalibraries)
endif()
if (AJA_BUILD_PLUGINS AND EXISTS ${AJA_PLUGINS_ROOT})
    aja_message(STATUS "adding ajaplugins...")
    add_subdirectory(ajaplugins)
endif()
if (AJA_BUILD_QA AND EXISTS ${AJA_QA_ROOT})
    aja_message(STATUS "adding qa...")
    add_subdirectory(qa)
endif()
if (AJA_BUILD_NONAJA AND EXISTS ${NON_AJA_ROOT})
    aja_message(STATUS "adding non-aja...")
    add_subdirectory(non-aja)
endif()

# Install NTV2 CMake files
if (AJA_INSTALL_SOURCES)
    install(FILES cmake/AJABuildOptions.cmake                DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/AJACommonDefines.cmake               DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/AJACommonFlags.cmake                 DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/AJACommonPaths.cmake                 DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/AJACommonVars.cmake                  DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/AJAHelpers.cmake                     DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/AJAQtHelpers.cmake                   DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/AJAVersionConfig.cmake               DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/linux_ldd_qt_libs.cmake              DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake)
    install(FILES cmake/toolchain/aja-ci-toolchain.cmake     DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake/toolchain)
    install(FILES cmake/toolchain/clang-unix_toolchain.cmake DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake/toolchain)
    install(FILES cmake/toolchain/clang-win_toolchain.cmake  DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake/toolchain)
    install(FILES cmake/toolchain/msvc_toolchain.cmake       DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake/toolchain)
    install(FILES cmake/bundle/linux/lin-ver.json.in         DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake/bundle/linux)
    install(FILES cmake/bundle/mac/Info.plist.in             DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake/bundle/mac)
    install(FILES cmake/bundle/windows/win-ver.rc.in         DESTINATION ${CMAKE_INSTALL_PREFIX}/cmake/bundle/windows)
    install(FILES CMakeLists.txt                             DESTINATION ${CMAKE_INSTALL_PREFIX}/)
endif()

=== ajaapps/CMakeLists.txt ===
# aja apps
if (AJA_BUILD_APPS)
    # aja core demos
    aja_add_subdirectory(crossplatform/demoapps/ntv2burn)
    aja_add_subdirectory(crossplatform/demoapps/ntv2burn4kquadrant)
    aja_add_subdirectory(crossplatform/demoapps/ntv2capture)
    aja_add_subdirectory(crossplatform/demoapps/ntv2capture4k)
    aja_add_subdirectory(crossplatform/demoapps/ntv2capture8k)
    aja_add_subdirectory(crossplatform/demoapps/ntv2dolbyplayer)
    aja_add_subdirectory(crossplatform/demoapps/ntv2enumerateboards)
    aja_add_subdirectory(crossplatform/demoapps/ntv2fieldburn)
    aja_add_subdirectory(crossplatform/demoapps/ntv2hdrsetup)
    aja_add_subdirectory(crossplatform/demoapps/ntv2llburn)
    aja_add_subdirectory(crossplatform/demoapps/ntv2outputtestpattern)
    aja_add_subdirectory(crossplatform/demoapps/ntv2player)
    aja_add_subdirectory(crossplatform/demoapps/ntv2player4k)
    aja_add_subdirectory(crossplatform/demoapps/ntv2player8k)
    aja_add_subdirectory(crossplatform/demoapps/ntv2switchbitfile)

    # nvidia demos
    aja_add_subdirectory(crossplatform/demoapps/NVIDIA/cudalowlatencydemo)
    # aja_add_subdirectory(crossplatform/demoapps/NVIDIA/dvplowlatencydemo) # TODO(paulh): Need to audit dependencies for open-source distribution.

    # tools
    aja_add_subdirectory(crossplatform/logjammer)
    aja_add_subdirectory(crossplatform/logreader)
    aja_add_subdirectory(crossplatform/ntv2firmwareinstaller)
    aja_add_subdirectory(crossplatform/ntv2thermo)
    aja_add_subdirectory(crossplatform/pciwhacker)
    aja_add_subdirectory(crossplatform/rdmawhacker)
    aja_add_subdirectory(crossplatform/regio)
    aja_add_subdirectory(crossplatform/supportlog)
    aja_add_subdirectory(crossplatform/testaux)
    aja_add_subdirectory(crossplatform/testcrc)
    aja_add_subdirectory(crossplatform/testframe)
    aja_add_subdirectory(crossplatform/testp2p)
    aja_add_subdirectory(crossplatform/testrdma)
    aja_add_subdirectory(crossplatform/vpidtool)

    if (NOT AJA_BUILD_OPENSOURCE)
        # retail apps/services
        aja_add_subdirectory(crossplatform/ajadaemon "AJA Retail Daemon" "AJA Retail Daemon")
        aja_add_subdirectory(crossplatform/controlpanel "AJA ControlPanel" "AJA ControlPanel - Retail Device Configuration")
        aja_add_subdirectory(crossplatform/controlroom "AJA ControlRoom" "AJA Control Room - Ingest & Playout Application")
		if (CMAKE_SYSTEM_NAME STREQUAL "Linux" AND AJA_BUILD_NONAJA)
			# ndibridge is currently Linux-only, and requires building libsamplerate
			aja_add_subdirectory(crossplatform/ndibridge "AJA NDI Bridge" "AJA NDI Bridge - Make It So")
		endif()

        # oem/internal tools
        # NOTE(paulh): ajalogger is MIT licensed but need to remove dependency on ajagui/AJAAboutBox
        aja_add_subdirectory(crossplatform/ajalogger "AJA Logger" "AJA Logger - Log All The Things")
        aja_add_subdirectory(crossplatform/hdmiinstatus)
        aja_add_subdirectory(crossplatform/konaburner)
        aja_add_subdirectory(crossplatform/mcap)
        aja_add_subdirectory(crossplatform/ntv2cmd)
        aja_add_subdirectory(crossplatform/ntv2watcher "AJA NTV2 Watcher" "AJA NTV2 Watcher")
        # aja_add_subdirectory(crossplatform/rovocontrol "AJA RovoControl" "AJA RovoControl")
        aja_add_subdirectory(crossplatform/systemtest "AJA System Test" "AJA System Test")

        # aja cc demos
        aja_add_subdirectory(crossplatform/demoapps/ntv2ccgrabber)
        aja_add_subdirectory(crossplatform/demoapps/ntv2ccplayer)

        # aja cuda demos (TODO)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2cudacapture)
        # aja hevc demos
        # NOTE: These demos use proprietary code and are not included in the open-source NTV2 distribution.
        aja_add_subdirectory(crossplatform/demoapps/ntv2encodehevc)
        aja_add_subdirectory(crossplatform/demoapps/ntv2encodehevcfile)
        aja_add_subdirectory(crossplatform/demoapps/ntv2encodehevcvif)

        # aja opengl demos (TODO)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2oglcapture)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2ogldpxreader)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2testOGL)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2ogloutput)

        # aja Qt-based demos (TODO)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2dpxplayer)
        aja_add_subdirectory(crossplatform/demoapps/ntv2konaipj2ksetup)
        aja_add_subdirectory(crossplatform/demoapps/ntv2konaipjsonsetup)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2playcorder)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2recorddpx)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2stereocapture)
        # aja_add_subdirectory(crossplatform/demoapps/ntv2playbackdpx)
    endif()
endif()

=== ajadriver/CMakeLists.txt ===
project(ajadriver)

# AJA does not yet provide sources for the Mac and Windows drivers under the MIT license.
# Place this text as a README.md file in the ajadriver/mac and ajadriver/win directories as a placeholder.
set(WIN_MAC_MIT_DRIVER_README 
    "# Windows & macOS NTV2 Device Driver\n"
    "The NTV2 device driver for Windows and macOS is not available under the MIT license at this time.\n"
    "Please download the AJA Software Installer for your AJA device from: https://www.aja.com/support\n\n"
    "# Linux NTV2 Device Driver\n"
    "To build the MIT-licensed NTV2 device driver on Linux:\n"
    "1. `cd ajadriver/linux && make`\n"
    "2. `cd ../../bin`\n"
    "3. `sudo ./load_ajantv2`\n\n"
    "Alternately the Linux driver can be installed via the AJA Software Installer for Linux, available from: https://www.aja.com/support\n"
)

if (AJA_BUILD_OPENSOURCE)
    file(WRITE win/README.md ${WIN_MAC_MIT_DRIVER_README})
    file(WRITE mac/README.md ${WIN_MAC_MIT_DRIVER_README})
endif()

# ajadriver
set(AJADRIVER_COMMON_HEADERS
    ntv2anc.h
    ntv2audio.h
    ntv2autocirc.h
    ntv2autofunc.h
    ntv2commonreg.h
    ntv2displayid.h
    ntv2genlock.h
    ntv2genregs.h
    ntv2hdmiedid.h
    ntv2hdmiin.h
    ntv2hdmiin4.h
    ntv2hdmiout4.h
    ntv2hin4reg.h
    ntv2hinreg.h
    ntv2hout4reg.h
    ntv2infoframe.h
    ntv2kona.h
    ntv2mcap.h
    ntv2pciconfig.h
    ntv2rp188.h
    ntv2setup.h
    ntv2system.h
    ntv2video.h
    ntv2vpid.h
    ntv2xpt.h
    ntv2xptlookup.h)
set(AJADRIVER_COMMON_SOURCES
    ntv2anc.c
    ntv2audio.c
    ntv2autocirc.c
    ntv2commonreg.c
    ntv2displayid.c
    ntv2genlock.c
    ntv2hdmiedid.c
    ntv2hdmiin.c
    ntv2hdmiin4.c
    ntv2hdmiout4.c
    ntv2infoframe.c
    ntv2kona.c
    ntv2mcap.c
    ntv2pciconfig.c
    ntv2rp188.c
    ntv2setup.c
    ntv2system.c
    ntv2video.c
    ntv2vpid.c
    ntv2xpt.c)

# ajadriver/linux
set(AJADRIVER_LINUX_HEADERS
    linux/driverdbg.h
    linux/fs1wait.h
    linux/ntv2dma.h
    linux/ntv2driverautocirculate.h
    linux/ntv2driverbigphysarea.h
    linux/ntv2driverdbgmsgctl.h
    linux/ntv2driver.h
    linux/ntv2driverstatus.h
    linux/ntv2drivertask.h
    linux/ntv2kona2.h
    linux/ntv2serial.h
    linux/registerio.h)
set(AJADRIVER_LINUX_SOURCES
    linux/ntv2dma.c
    linux/ntv2driverautocirculate.c
    linux/ntv2driver.c
    linux/ntv2driverdbgmsgctl.c
    linux/ntv2driverstatus.c
    linux/ntv2drivertask.c
    linux/ntv2kona2.c
    linux/ntv2serial.c
    linux/registerio.c)
if (NOT AJA_BUILD_OPENSOURCE)
    # add HEVC sources
    set(AJADRIVER_LINUX_HEADERS
        ${AJADRIVER_LINUX_HEADERS}
        linux/hevccommand.h
        linux/hevccommon.h
        linux/hevcconstants.h
        linux/hevcdriver.h
        linux/hevcinterrupt.h
        linux/hevcparams.h
        linux/hevcpublic.h
        linux/hevcregister.h
        linux/hevcstream.h)
    set(AJADRIVER_LINUX_SOURCES
        ${AJADRIVER_LINUX_SOURCES}
        linux/hevcapi.c
        linux/hevccommand.c
        linux/hevcdriver.c
        linux/hevcinterrupt.c
        linux/hevcparams.c
        linux/hevcregister.c
        linux/hevcstream.c)
endif()

set(AJADRIVER_LINUX_BUILD_FILES
    linux/Makefile
    linux/nvidia-ko-to-module-symvers)
set(AJADRIVER_LINUX_LOAD_FILES
    ${AJA_LIBRARIES_ROOT}/bin/load_ajantv2
    ${AJA_LIBRARIES_ROOT}/bin/unload_ajantv2)
# ajadriver target sources
set(AJADRIVER_TARGET_SOURCES
    ${AJADRIVER_COMMON_HEADERS}
    ${AJADRIVER_COMMON_SOURCES})

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
    aja_message(STATUS "Windows driver CMake build not yet implemented!")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    aja_message(STATUS "macOS driver CMake build not yet implemented!")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(AJADRIVER_TARGET_SOURCES
        ${AJADRIVER_TARGET_SOURCES}
        ${AJADRIVER_LINUX_HEADERS}
        ${AJADRIVER_LINUX_SOURCES})
endif()

add_custom_target(ajadriver_install ${AJADRIVER_TARGET_SOURCES})

# Windows
if (AJA_BUILD_OPENSOURCE AND AJA_INSTALL_SOURCES)
    install(FILES win/README.md DESTINATION ${CMAKE_INSTALL_PREFIX}/ajadriver/win)
endif()
# macOS
if (AJA_BUILD_OPENSOURCE AND AJA_INSTALL_SOURCES)
    install(FILES mac/README.md DESTINATION ${CMAKE_INSTALL_PREFIX}/ajadriver/mac)
endif()
# Linux
if (AJA_INSTALL_HEADERS)
    install(FILES ${AJADRIVER_LINUX_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ajadriver/linux)
endif()
if (AJA_INSTALL_SOURCES)
    install(FILES ${AJADRIVER_LINUX_SOURCES}              DESTINATION ${CMAKE_INSTALL_PREFIX}/ajadriver/linux)
    install(FILES ${AJADRIVER_LINUX_BUILD_FILES}          DESTINATION ${CMAKE_INSTALL_PREFIX}/ajadriver/linux)
    install(FILES ${AJADRIVER_LINUX_LOAD_FILES}           DESTINATION ${CMAKE_INSTALL_PREFIX}/ajalibraries/bin)
    install(FILES ${AJA_CMAKE_DIR}/../build/common.mk     DESTINATION ${CMAKE_INSTALL_PREFIX}/build)
    install(FILES ${AJA_CMAKE_DIR}/../build/configure.mk  DESTINATION ${CMAKE_INSTALL_PREFIX}/build)
    install(FILES ${AJA_CMAKE_DIR}/../build/internal.mk   DESTINATION ${CMAKE_INSTALL_PREFIX}/build)
    install(FILES ${AJA_CMAKE_DIR}/../build/qt.mk         DESTINATION ${CMAKE_INSTALL_PREFIX}/build)
    install(FILES ${AJA_CMAKE_DIR}/../build/sdkversion.mk DESTINATION ${CMAKE_INSTALL_PREFIX}/build)
    install(FILES ${AJA_CMAKE_DIR}/../build/targets.mk    DESTINATION ${CMAKE_INSTALL_PREFIX}/build)
endif()
# common
if (AJA_INSTALL_HEADERS)
    install(FILES ${AJADRIVER_COMMON_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ajadriver)
    install(FILES ${AJA_LIB_NTV2_ROOT}/includes/ntv2driverprocamp.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ajalibraries/ajantv2/includes)
endif()
if (AJA_INSTALL_SOURCES)
    install(FILES ${AJADRIVER_COMMON_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajadriver)
    install(FILES ${AJA_LIB_NTV2_ROOT}/src/ntv2driverprocamp.cpp DESTINATION ${CMAKE_INSTALL_PREFIX}/ajalibraries/ajantv2/src)
endif()

=== ajalibraries/CMakeLists.txt ===
# ajaconv
if (EXISTS ${AJA_LIB_CONV_ROOT})
	if (NOT AJA_BUILD_OPENSOURCE)
		aja_add_subdirectory(ajaconv)
		if (AJA_BUILD_TESTS)
			aja_add_subdirectory(ajaconv/test)
		endif()
	endif()
endif()

# ajantv2
if (EXISTS ${AJA_LIB_NTV2_ROOT})
    aja_add_subdirectory(ajantv2)
	if (AJA_BUILD_TESTS)
		aja_add_subdirectory(ajabase/test)
		aja_add_subdirectory(ajantv2/test)
	endif()
endif()

# ajacc
if (EXISTS ${AJA_LIB_CC_ROOT}
	AND EXISTS ${AJA_LIB_NTV2_ROOT})
	if (NOT AJA_BUILD_OPENSOURCE)
		aja_add_subdirectory(ajacc)
		if (AJA_BUILD_TESTS)
			aja_add_subdirectory(ajacc/test)
		endif()
	endif()
endif()

# ajagui
if (EXISTS ${AJA_LIB_GUI_ROOT}
	AND EXISTS ${AJA_LIB_NTV2_ROOT})
	if (NOT AJA_BUILD_OPENSOURCE)
		aja_add_subdirectory(ajainternal/gui)
	endif()
endif()

# ajastreams
if (EXISTS ${AJA_LIB_STREAMS_ROOT}
	AND EXISTS ${AJA_LIB_NTV2_ROOT}
	AND EXISTS ${AJA_LIB_CONV_ROOT})
	if (NOT AJA_BUILD_OPENSOURCE)
		# Drastic deck control lib (AKA vvwexts2)
		aja_add_subdirectory(streams/drasticproj "Drastic Technologies Ltd.")
		aja_add_subdirectory(streams)
		if (AJA_BUILD_TESTS)
			aja_add_subdirectory(streams/test)
		endif()
	endif()
endif()

if (EXISTS ${AJA_LIB_DOCS_ROOT}
	AND EXISTS ${AJA_LIB_NTV2_ROOT}
	AND AJA_BUILD_DOCS)
	aja_add_subdirectory(docs)
endif()

=== ajadriver/linux/Makefile ===
# SPDX-License-Identifier: MIT
#
# Copyright (C) 2004 - 2021 AJA Video Systems, Inc.
#

# Makefile for AJA Linux Video NTV2 Driver
DIR := $(strip $(shell dirname $(abspath $(lastword $(MAKEFILE_LIST)))))

#DRIVERDIR	?= $(DIR)
KVERSION	?= $(shell uname -r)
KDIR		?= /lib/modules/$(KVERSION)/build

# EXTRA_DEPS = -DNTV2_DEPRECATE_14_0 -DNTV2_DEPRECATE_14_1 

include $(DIR)/../../build/configure.mk
include $(DIR)/../../build/sdkversion.mk

CC			 ?= gcc

DRIVERTARGET = $(NTV2TARGET).o
INCLUDES 	 = -I$(A_LIB_NTV2_INC) -I$(A_LINUX_DRIVER_PATH) -I$(A_LIB_NTV2_SRC) -I$(A_LIB_NTV2_SRC)/lin -I$(A_DRIVER_PATH)
VERSIONING 	 = -DSDKVER_MAJ=$(SDKVER_MAJ) -DSDKVER_MIN=$(SDKVER_MIN) -DSDKVER_PNT=$(SDKVER_PNT) -DSDKVER_BLD=$(SDKVER_BLD) -DAJA_BETA=$(AJA_BETA) -DAJA_DEBUG=$(AJA_DEBUG) 
EXTRA_CFLAGS += -DAJALinux -DXENA2 $(DBG) -D$(NTV2TARGET) -D$(LINUX_DISTRO) -D$(A_ARCH) $(EXTRA_DEPS) $(VERSIONING) $(INCLUDES) -Wall

ifdef AJA_HEVC
	EXTRA_CFLAGS += -DAJA_HEVC=$(AJA_HEVC)
endif

ifdef AJA_RDMA
ifeq ($(NVIDIA_SRC_DIR),)
	NVIDIA_SRC_DIR := $(shell find /usr/src/nvidia-* -name nv-p2p.h 2>/dev/null|head -1|xargs dirname 2>/dev/null)
endif
ifeq ($(NVIDIA_SRC_DIR),)
	NVIDIA_SRC_DIR := $(shell find /usr/src/linux-* -name nv-p2p.h 2>/dev/null|head -1|xargs dirname 2>/dev/null)
endif
	EXTRA_CFLAGS += -I$(NVIDIA_SRC_DIR) -DAJA_RDMA=$(AJA_RDMA)
ifdef AJA_IGPU
	EXTRA_CFLAGS += -DAJA_IGPU=$(AJA_IGPU)
else
ifeq ($(NVIDIA_SYMVERS),)
	NVIDIA_KO ?= $(shell find /lib/modules/$(KVERSION)/ -name 'nvidia*.ko'|grep -P 'nvidia(_[0-9]+)?.ko'|head -1)
	NVIDIA_GEN_SYMVERS := ./nvidia-ko-to-module-symvers $(NVIDIA_KO) $(DIR)/nvidia.symvers
	NVIDIA_SYMVERS := $(DIR)/nvidia.symvers
endif
endif
endif

ifdef AJA_CREATE_DEVICE_NODES
	EXTRA_CFLAGS += -DAJA_CREATE_DEVICE_NODES=$(AJA_CREATE_DEVICE_NODES)
endif

DRIVERSRCS = ntv2devicefeatures.c \
			ntv2driver.c \
			ntv2driverautocirculate.c \
			ntv2driverdbgmsgctl.c \
			ntv2dma.c \
			ntv2driverstatus.c \
			ntv2kona2.c \
			ntv2driverprocamp.c \
			ntv2drivertask.c \
			ntv2vpidfromspec.c \
			registerio.c \
			ntv2serial.c \
			../ntv2commonreg.c \
			../ntv2hdmiedid.c \
			../ntv2hdmiin.c \
			../ntv2hdmiin4.c \
			../ntv2infoframe.c \
			../ntv2hdmiout4.c \
			../ntv2displayid.c \
			../ntv2genlock.c \
			../ntv2mcap.c \
			../ntv2pciconfig.c \
			../ntv2system.c \
			../ntv2anc.c \
			../ntv2xpt.c \
			../ntv2kona.c \
			../ntv2vpid.c \
			../ntv2rp188.c \
			../ntv2setup.c

DRIVEROBJS = $(patsubst %.c,%.o,$(DRIVERSRCS))

DRIVERINCS = $(A_LIB_NTV2_INC)/ntv2audiodefines.h \
			$(A_LIB_NTV2_INC)/ntv2videodefines.h \
			$(A_LIB_NTV2_INC)/ntv2devicefeatures.hh \
			$(A_LIB_NTV2_INC)/ntv2driverprocamp.h \
			$(A_LINUX_DRIVER_PATH)/driverdbg.h \
			$(A_LINUX_DRIVER_PATH)/ntv2driver.h \
			$(A_LINUX_DRIVER_PATH)/ntv2driverautocirculate.h \
			$(A_LINUX_DRIVER_PATH)/ntv2dma.h \
			$(A_LINUX_DRIVER_PATH)/ntv2driverdbgmsgctl.h \
			$(A_LINUX_DRIVER_PATH)/ntv2driverstatus.h \
			$(A_LINUX_DRIVER_PATH)/ntv2drivertask.h \
			$(A_LIB_NTV2_INC)/ntv2vpidfromspec.h \
			$(A_LIB_NTV2_INC)/ntv2enums.h \
			$(A_LIB_NTV2_INC)/ntv2publicinterface.h \
			$(A_LIB_NTV2_SRC)/lin/ntv2linuxpublicinterface.h \
			$(A_LINUX_DRIVER_PATH)/../ntv2xptlookup.h \
			$(A_LINUX_DRIVER_PATH)/registerio.h \
			$(A_LINUX_DRIVER_PATH)/ntv2serial.h \
			$(A_DRIVER_PATH)/ntv2commonreg.h \
			$(A_DRIVER_PATH)/ntv2hdmiin.h \
			$(A_DRIVER_PATH)/ntv2hinreg.h \
			$(A_DRIVER_PATH)/ntv2hdmiin4.h \
			$(A_DRIVER_PATH)/ntv2hin4reg.h \
			$(A_DRIVER_PATH)/ntv2hdmiout4.h \
			$(A_DRIVER_PATH)/ntv2hout4reg.h \
			$(A_DRIVER_PATH)/ntv2hdmiedid.h \
			$(A_DRIVER_PATH)/ntv2infoframe.h \
			$(A_DRIVER_PATH)/ntv2genregs.h \
			$(A_DRIVER_PATH)/ntv2kona.h \
			$(A_DRIVER_PATH)/ntv2mcap.h \
			$(A_DRIVER_PATH)/ntv2pciconfig.h \
			$(A_DRIVER_PATH)/ntv2system.h \
			$(A_DRIVER_PATH)/ntv2vpid.h \
			$(A_DRIVER_PATH)/ntv2xpt.h \
			$(A_DRIVER_PATH)/ntv2anc.h \
			$(A_DRIVER_PATH)/ntv2setup.h

ifdef AJA_HEVC
HEVCSRCS =	hevcdriver.c \
			hevcparams.c \
			hevcregister.c \
			hevcapi.c \
			hevcinterrupt.c \
			hevccommand.c \
			hevcstream.c

HEVCOBJS = $(patsubst %.c,%.o,$(HEVCSRCS))

HEVCINCS =	$(A_LINUX_DRIVER_PATH)/hevcpublic.h \
			$(A_LINUX_DRIVER_PATH)/hevccommon.h \
			$(A_LINUX_DRIVER_PATH)/hevcdriver.h \
			$(A_LINUX_DRIVER_PATH)/hevcparams.h \
			$(A_LINUX_DRIVER_PATH)/hevcconstants.h \
			$(A_LINUX_DRIVER_PATH)/hevcregister.h \
			$(A_LINUX_DRIVER_PATH)/hevcinterrupt.h \
			$(A_LINUX_DRIVER_PATH)/hevccommand.h \
			$(A_LINUX_DRIVER_PATH)/hevcstream.h
else
HEVCSRCS =
HEVCOBJS =
HEVCINCS =
endif

ifdef AJA_RDMA
RDMAINCS =	$(NVIDIA_SRC_DIR)/nv-p2p.h
else
RDMAINCS =
endif

obj-m				:= $(DRIVERTARGET)
$(NTV2TARGET)-objs 	:= $(DRIVEROBJS) $(HEVCOBJS)

default: all 
	@echo linux distro: $(LINUX_DISTRO)
	@echo lib: $(LIB)
ifdef AJA_RDMA
ifdef AJA_IGPU
	$(MAKE) -C $(KDIR) M=$(A_LINUX_DRIVER_PATH) DRIVERDIR=$(A_LINUX_DRIVER_PATH) modules
else
	${NVIDIA_GEN_SYMVERS}
	$(MAKE) -C $(KDIR) M=$(A_LINUX_DRIVER_PATH) DRIVERDIR=$(A_LINUX_DRIVER_PATH) modules KBUILD_EXTRA_SYMBOLS=$(NVIDIA_SYMVERS)
endif
else
	$(MAKE) -C $(KDIR) M=$(A_LINUX_DRIVER_PATH) DRIVERDIR=$(A_LINUX_DRIVER_PATH) modules
endif
	$(call ensure_dir_exists, $(A_UBER_BIN))
	if [ -d "$(A_LIBRARIES_PATH)/bin" ]; then cp -f $(A_LIBRARIES_PATH)/bin/*load_ajantv2 $(A_UBER_BIN); fi
	cp $(NTV2TARGET).ko $(A_UBER_BIN)

modules_install:
	$(MAKE) -C $(KDIR) M=$(A_LINUX_DRIVER_PATH) modules_install

all: $(DRIVERINCS) $(DRIVERSRCS) $(HEVCINCS) $(HEVCSRCS) $(RDMAINCS)

# Make a symlink to the C-only CPP files we need in classes.

ntv2devicefeatures.c:
	ln -sf $(A_LIB_NTV2_SRC)/ntv2devicefeatures.cpp $(A_LINUX_DRIVER_PATH)/ntv2devicefeatures.c

ntv2driverprocamp.c: 
	ln -sf $(A_LIB_NTV2_SRC)/ntv2driverprocamp.cpp $(A_LINUX_DRIVER_PATH)/ntv2driverprocamp.c

ntv2vpidfromspec.c: 
	ln -sf $(A_LIB_NTV2_SRC)/ntv2vpidfromspec.cpp $(A_LINUX_DRIVER_PATH)/ntv2vpidfromspec.c

.PHONY: clean cleandeps realclean

clean:
	rm -f $(A_UBER_BIN)/*.ko $(A_DRIVER_PATH)/*.o $(A_DRIVER_PATH)/.*o.cmd *.ko *.o .*o.cmd *.mod.c *~ errors.txt semantic.cache
	rm -f *.markers *.symvers *.order *.o.ur-safe *.mod
	rm -f ntv2devicefeatures.*
	rm -f ntv2driverprocamp.c
	rm -f ntv2vpidfromspec.c
	rm -f TAGS
	rm -rf .tmp_versions
	rm -rf .cache.mk
	rm -rf nvidia.symvers

cleandeps: clean
realclean: clean

etags:
	etags *.h *.c ../*.h ../*.c ../../ajalibraries/ajantv2/includes/*.h

=== ajalibraries/ajaanc/CMakeLists.txt ===
project(ajaanc)

set(AJAANC_TARGET_INCLUDE_DIRS
    ${AJA_LIBRARIES_ROOT}
    ${AJA_LIB_ANC_ROOT}/includes
    ${AJA_LIB_BASE_ROOT}/includes
    ${AJA_LIB_NTV2_ROOT}/includes)

set(AJAANC_HEADERS
    includes/ancillarydata_cea608.h
    includes/ancillarydata_cea608_line21.h
    includes/ancillarydata_cea608_vanc.h
    includes/ancillarydata_cea708.h
    includes/ancillarydatafactory.h
    includes/ancillarydata_framestatusinfo524D.h
    includes/ancillarydata_framestatusinfo5251.h
    includes/ancillarydata.h
    includes/ancillarydata_hdr_hdr10.h
    includes/ancillarydata_hdr_hlg.h
    includes/ancillarydata_hdr_sdr.h
    includes/ancillarydata_timecode_atc.h
    includes/ancillarydata_timecode.h
    includes/ancillarydata_timecode_vitc.h
    includes/ancillarylist.h
)

set(AJAANC_SOURCES
    src/ancillarydata_cea608.cpp
    src/ancillarydata_cea608_line21.cpp
    src/ancillarydata_cea608_vanc.cpp
    src/ancillarydata_cea708.cpp
    src/ancillarydata.cpp
    src/ancillarydatafactory.cpp
    src/ancillarydata_framestatusinfo524D.cpp
    src/ancillarydata_framestatusinfo5251.cpp
    src/ancillarydata_hdr_hdr10.cpp
    src/ancillarydata_hdr_hlg.cpp
    src/ancillarydata_hdr_sdr.cpp
    src/ancillarydata_timecode_atc.cpp
    src/ancillarydata_timecode.cpp
    src/ancillarydata_timecode_vitc.cpp
    src/ancillarylist.cpp
)

set(AJAANC_TARGET_SOURCES ${AJAANC_SOURCES} ${AJAANC_HEADERS})

add_library(ajaanc STATIC ${AJAANC_TARGET_SOURCES})
target_include_directories(ajaanc PUBLIC ${AJAANC_TARGET_INCLUDE_DIRS})
target_link_libraries(ajaanc PUBLIC ajantv2)

if (AJA_BUILD_SHARED)
    add_library(ajaancshared SHARED ${AJAANC_TARGET_SOURCES})
    target_include_directories(ajaancshared PUBLIC ${AJAANC_TARGET_INCLUDE_DIRS})
    target_link_libraries(ajaancshared PUBLIC ajantv2shared)
endif()

=== ajalibraries/ajantv2/CMakeLists.txt ===
project(ajantv2)

if(CMAKE_CXX_STANDARD LESS 11)
    remove_definitions(
        -DAJA_USE_CPLUSPLUS11
        -DNTV2_USE_CPLUSPLUS11)
endif()

remove_definitions(
    -DUNICODE
    -D_UNICODE
    -DQT_LARGEFILE_SUPPORT)

set(AJANTV2_TARGET_INCLUDE_DIRS
    includes
    ${AJA_LIB_ANC_ROOT}/includes
    ${AJA_LIBRARIES_ROOT}
    ${AJA_LIB_BASE_ROOT}
    ${CMAKE_CURRENT_BINARY_DIR})

# ajantv2
set(AJANTV2_HEADERS
    includes/ajaexport.h
    includes/ajatypes.h
    includes/basemachinecontrol.h
    includes/ntv2audiodefines.h
    includes/ntv2bft.h
    includes/ntv2bitfile.h
    includes/ntv2bitfilemanager.h
    includes/ntv2boardfeatures.h
    includes/ntv2boardscan.h
    includes/ntv2card.h
    includes/ntv2choosableboard.h
    includes/ntv2config2022.h
    includes/ntv2config2110.h
    includes/ntv2configts2022.h
    includes/ntv2cscmatrix.h
    includes/ntv2debug.h
    includes/ntv2debugmacros.h
    includes/ntv2devicefeatures.h
    includes/ntv2devicefeatures.hh # generated by sdkgen
    src/ntv2devicefeatures.hpp # generated by sdkgen
    includes/ntv2devicescanner.h
    includes/ntv2discover.h
    includes/ntv2driverinterface.h
    includes/ntv2endian.h
    includes/ntv2enhancedcsc.h
    includes/ntv2enums.h
    includes/ntv2fixed.h
    includes/ntv2formatdescriptor.h
    includes/ntv2konaflashprogram.h
    includes/ntv2m31enums.h
    includes/ntv2m31publicinterface.h
    includes/ntv2mailbox.h
    includes/ntv2mbcontroller.h
    includes/ntv2mcsfile.h
    includes/ntv2nubaccess.h
    includes/ntv2nubpktcom.h
    includes/ntv2nubtypes.h
    includes/ntv2publicinterface.h
    includes/ntv2registerexpert.h
    includes/ntv2registers2022.h
    includes/ntv2registers2110.h
    includes/ntv2registersmb.h
    includes/ntv2resample.h
    includes/ntv2routingexpert.h
    includes/ntv2rp188.h
    includes/ntv2rp215.h
    includes/ntv2serialcontrol.h
    includes/ntv2signalrouter.h
    includes/ntv2spiinterface.h
    includes/ntv2supportlogger.h
    includes/ntv2task.h
    includes/ntv2testpatterngen.h
    includes/ntv2transcode.h
    includes/ntv2tshelper.h
    includes/ntv2utf8.h
    includes/ntv2utils.h
    includes/ntv2verticalfilter.h
    includes/ntv2videodefines.h
    includes/ntv2virtualregisters.h
    includes/ntv2vpid.h
    includes/ntv2vpidfromspec.h)
set(AJANTV2_SOURCES
    src/ntv2anc.cpp
    src/ntv2audio.cpp
    src/ntv2autocirculate.cpp
    src/ntv2bitfile.cpp
    src/ntv2bitfilemanager.cpp
    src/ntv2card.cpp
    src/ntv2config2022.cpp
    src/ntv2config2110.cpp
    src/ntv2configts2022.cpp
    src/ntv2csclut.cpp
    src/ntv2cscmatrix.cpp
    src/ntv2debug.cpp
    src/ntv2devicefeatures.cpp
    src/ntv2devicescanner.cpp
    src/ntv2discover.cpp
    src/ntv2dma.cpp
    src/ntv2driverinterface.cpp
    src/ntv2dynamicdevice.cpp
    src/ntv2enhancedcsc.cpp
    src/ntv2formatdescriptor.cpp
    src/ntv2hdmi.cpp
    src/ntv2hevc.cpp
    src/ntv2interrupts.cpp
    src/ntv2konaflashprogram.cpp
    src/ntv2mailbox.cpp
    src/ntv2mbcontroller.cpp
    src/ntv2mcsfile.cpp
    src/ntv2nubaccess.cpp
    src/ntv2nubpktcom.cpp
    src/ntv2publicinterface.cpp
    src/ntv2register.cpp
    src/ntv2registerexpert.cpp
    src/ntv2resample.cpp
    src/ntv2routingexpert.cpp
    src/ntv2rp188.cpp
    src/ntv2rp215.cpp
    src/ntv2serialcontrol.cpp
    src/ntv2signalrouter.cpp
    src/ntv2spiinterface.cpp
    src/ntv2subscriptions.cpp
    src/ntv2supportlogger.cpp
    src/ntv2task.cpp
    src/ntv2testpatterngen.cpp
    src/ntv2transcode.cpp
    src/ntv2utf8.cpp
    src/ntv2utils.cpp
    src/ntv2verticalfilter.cpp
    src/ntv2vpid.cpp
    src/ntv2vpidfromspec.cpp)
# ntv2driverinterface/publicinterface
set(AJANTV2_WIN_HEADERS
    src/win/ntv2windriverinterface.h
    src/win/ntv2winpublicinterface.h)
set(AJANTV2_WIN_SOURCES
    # src/win/dllmain.cpp
    src/win/ntv2windriverinterface.cpp)
set(AJANTV2_MAC_HEADERS
    src/mac/ntv2macdriverinterface.h
    src/mac/ntv2macpublicinterface.h)
set(AJANTV2_MAC_SOURCES
    src/mac/ntv2macdriverinterface.cpp)
set(AJANTV2_LIN_HEADERS
    src/lin/ntv2linuxdriverinterface.h
    src/lin/ntv2linuxpublicinterface.h)
set(AJANTV2_LIN_SOURCES
    src/lin/ntv2linuxdriverinterface.cpp)
# ajantv2 utilityfiles
set(AJANTV2_UTILITY_PUBLIC_HEADERS
    utilityfiles/public/ntv2firmwareinstallerthread.h
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.h)
set(AJANTV2_UTILITY_PUBLIC_SOURCES
    utilityfiles/public/ntv2firmwareinstallerthread.cpp
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.cpp)
# ajantv2 hevc
if (NOT AJA_BUILD_OPENSOURCE)
    aja_message(STATUS "added ajantv2 HEVC/M31 codec")
    set(AJANTV2_HEVC_HEADERS
        codecs/hevc/m31/ntv2m31.h
        codecs/hevc/m31/ntv2m31cparam.h
        codecs/hevc/m31/ntv2m31ehparam.h
        codecs/hevc/m31/ntv2m31vaparam.h
        codecs/hevc/m31/ntv2m31vinparam.h
        codecs/hevc/m31/ntv2m31viparam.h)
    set(AJANTV2_HEVC_SOURCES
        codecs/hevc/m31/ntv2m31.cpp
        codecs/hevc/m31/ntv2m31cparam.cpp
        codecs/hevc/m31/ntv2m31ehparam.cpp
        codecs/hevc/m31/ntv2m31vaparam.cpp
        codecs/hevc/m31/ntv2m31vinparam.cpp
        codecs/hevc/m31/ntv2m31viparam.cpp)
    # `cmake --install` deployments
    if (AJA_INSTALL_HEADERS)
        install(FILES ${AJANTV2_HEVC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ajalibraries/ajantv2/codecs/hevc/m31)
    endif()
    if (AJA_INSTALL_SOURCES)
        install(FILES ${AJANTV2_HEVC_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajalibraries/ajantv2/codecs/hevc/m31)
    endif()
endif()

if (AJA_BUILDING_CMAKE)
    add_definitions(-DAJA_BUILDING_CMAKE)
    configure_file(includes/version.h.in includes/version.h @ONLY)
    install(FILES ${CMAKE_BINARY_DIR}/ajalibraries/ajantv2/includes/version.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ajalibraries/ajantv2/includes)
endif()

# ajaanc
set(AJAANC_HEADERS
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydatafactory.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea608.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea608_line21.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea608_vanc.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_cea708.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_framestatusinfo524D.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_framestatusinfo5251.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_hdr_hdr10.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_hdr_hlg.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_hdr_sdr.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_timecode.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_timecode_atc.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarydata_timecode_vitc.h
    ${AJA_LIB_ANC_ROOT}/includes/ancillarylist.h)
set(AJAANC_SOURCES
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydatafactory.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea608.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea608_line21.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea608_vanc.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_cea708.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_framestatusinfo524D.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_framestatusinfo5251.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_hdr_hdr10.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_hdr_hlg.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_hdr_sdr.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_timecode.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_timecode_atc.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarydata_timecode_vitc.cpp
    ${AJA_LIB_ANC_ROOT}/src/ancillarylist.cpp)

# ajabase
set(AJABASE_COMMON_HEADERS
    ${AJA_LIB_BASE_ROOT}/common/ajarefptr.h
    ${AJA_LIB_BASE_ROOT}/common/audioutilities.h
    ${AJA_LIB_BASE_ROOT}/common/buffer.h
    ${AJA_LIB_BASE_ROOT}/common/bytestream.h
    ${AJA_LIB_BASE_ROOT}/common/circularbuffer.h
    ${AJA_LIB_BASE_ROOT}/common/cli_utils.h
    ${AJA_LIB_BASE_ROOT}/common/common.h
    ${AJA_LIB_BASE_ROOT}/common/dpxfileio.h
    ${AJA_LIB_BASE_ROOT}/common/dpx_hdr.h
    ${AJA_LIB_BASE_ROOT}/common/export.h
    ${AJA_LIB_BASE_ROOT}/common/guid.h
    ${AJA_LIB_BASE_ROOT}/common/options_popt.h
    ${AJA_LIB_BASE_ROOT}/common/performance.h
    ${AJA_LIB_BASE_ROOT}/common/pixelformat.h
    ${AJA_LIB_BASE_ROOT}/common/public.h
    ${AJA_LIB_BASE_ROOT}/common/rawfile.h
    ${AJA_LIB_BASE_ROOT}/common/testpatterngen.h
    ${AJA_LIB_BASE_ROOT}/common/timebase.h
    ${AJA_LIB_BASE_ROOT}/common/timecode.h
    ${AJA_LIB_BASE_ROOT}/common/timecodeburn.h
    ${AJA_LIB_BASE_ROOT}/common/timer.h
    ${AJA_LIB_BASE_ROOT}/common/types.h
    ${AJA_LIB_BASE_ROOT}/common/videotypes.h
    ${AJA_LIB_BASE_ROOT}/common/videoutilities.h
    ${AJA_LIB_BASE_ROOT}/common/wavewriter.h)
set(AJABASE_NETWORK_HEADERS
    ${AJA_LIB_BASE_ROOT}/network/ip_socket.h
    ${AJA_LIB_BASE_ROOT}/network/tcp_socket.h
    ${AJA_LIB_BASE_ROOT}/network/udp_socket.h)
set(AJABASE_PERSISTENCE_HEADERS
    ${AJA_LIB_BASE_ROOT}/persistence/persistence.h
    ${AJA_LIB_BASE_ROOT}/persistence/sqlite3.h)
set(AJABASE_PNP_HEADERS
    ${AJA_LIB_BASE_ROOT}/pnp/pnp.h)
set(AJABASE_SYS_HEADERS
    ${AJA_LIB_BASE_ROOT}/system/atomic.h
    ${AJA_LIB_BASE_ROOT}/system/debug.h
    ${AJA_LIB_BASE_ROOT}/system/debugshare.h
    ${AJA_LIB_BASE_ROOT}/system/diskstatus.h
    ${AJA_LIB_BASE_ROOT}/system/event.h
    ${AJA_LIB_BASE_ROOT}/system/file_io.h
    ${AJA_LIB_BASE_ROOT}/system/info.h
    ${AJA_LIB_BASE_ROOT}/system/lock.h
    ${AJA_LIB_BASE_ROOT}/system/log.h
    ${AJA_LIB_BASE_ROOT}/system/make_unique_shim.h
    ${AJA_LIB_BASE_ROOT}/system/memory.h
    ${AJA_LIB_BASE_ROOT}/system/process.h
    ${AJA_LIB_BASE_ROOT}/system/system.h
    ${AJA_LIB_BASE_ROOT}/system/systemtime.h
    ${AJA_LIB_BASE_ROOT}/system/thread.h)
set(AJABASE_COMMON_SOURCES
    ${AJA_LIB_BASE_ROOT}/common/audioutilities.cpp
    ${AJA_LIB_BASE_ROOT}/common/buffer.cpp
    ${AJA_LIB_BASE_ROOT}/common/common.cpp
    ${AJA_LIB_BASE_ROOT}/common/dpxfileio.cpp
    ${AJA_LIB_BASE_ROOT}/common/dpx_hdr.cpp
    ${AJA_LIB_BASE_ROOT}/common/guid.cpp
    ${AJA_LIB_BASE_ROOT}/common/options_popt.cpp
    ${AJA_LIB_BASE_ROOT}/common/performance.cpp
    ${AJA_LIB_BASE_ROOT}/common/pixelformat.cpp
    ${AJA_LIB_BASE_ROOT}/common/testpatterngen.cpp
    ${AJA_LIB_BASE_ROOT}/common/timebase.cpp
    ${AJA_LIB_BASE_ROOT}/common/timecode.cpp
    ${AJA_LIB_BASE_ROOT}/common/timecodeburn.cpp
    ${AJA_LIB_BASE_ROOT}/common/timer.cpp
    ${AJA_LIB_BASE_ROOT}/common/videoutilities.cpp
    ${AJA_LIB_BASE_ROOT}/common/wavewriter.cpp)
set(AJABASE_NETWORK_SOURCES
    ${AJA_LIB_BASE_ROOT}/network/ip_socket.cpp
    ${AJA_LIB_BASE_ROOT}/network/tcp_socket.cpp
    ${AJA_LIB_BASE_ROOT}/network/udp_socket.cpp)
set(AJABASE_PERSISTENCE_SOURCES
    ${AJA_LIB_BASE_ROOT}/persistence/persistence.cpp
    ${AJA_LIB_BASE_ROOT}/persistence/sqlite3.c)
set(AJABASE_PNP_SOURCES
    ${AJA_LIB_BASE_ROOT}/pnp/pnp.cpp)
set(AJABASE_SYS_SOURCES
    ${AJA_LIB_BASE_ROOT}/system/atomic.cpp
    ${AJA_LIB_BASE_ROOT}/system/debug.cpp
    ${AJA_LIB_BASE_ROOT}/system/diskstatus.cpp
    ${AJA_LIB_BASE_ROOT}/system/event.cpp
    ${AJA_LIB_BASE_ROOT}/system/file_io.cpp
    ${AJA_LIB_BASE_ROOT}/system/info.cpp
    ${AJA_LIB_BASE_ROOT}/system/lock.cpp
    ${AJA_LIB_BASE_ROOT}/system/log.cpp
    ${AJA_LIB_BASE_ROOT}/system/memory.cpp
    ${AJA_LIB_BASE_ROOT}/system/process.cpp
    ${AJA_LIB_BASE_ROOT}/system/system.cpp
    ${AJA_LIB_BASE_ROOT}/system/systemtime.cpp
    ${AJA_LIB_BASE_ROOT}/system/thread.cpp)
# ajabase windows
set(AJABASE_PNP_WIN_HEADERS
    ${AJA_LIB_BASE_ROOT}/pnp/windows/pnpimpl.h)
set(AJABASE_PNP_WIN_SOURCES
    ${AJA_LIB_BASE_ROOT}/pnp/windows/pnpimpl.cpp)
set(AJABASE_SYS_WIN_HEADERS
    ${AJA_LIB_BASE_ROOT}/system/windows/eventimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/infoimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/lockimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/processimpl.h
    ${AJA_LIB_BASE_ROOT}/system/windows/threadimpl.h)
set(AJABASE_SYS_WIN_SOURCES

=== ajaapps/crossplatform/logjammer/CMakeLists.txt ===
project(logjammer)

set(LOGJAMMER_TARGET_INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${AJA_LIBRARIES_ROOT}
	${AJA_LIB_NTV2_ROOT}/includes)

set(LOGJAMMER_SOURCES main.cpp)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(LOGJAMMER_TARGET_SOURCES
	${LOGJAMMER_SOURCES})

add_executable(logjammer ${LOGJAMMER_TARGET_SOURCES})
add_dependencies(logjammer ajantv2)
target_include_directories(logjammer PUBLIC ${LOGJAMMER_TARGET_INCLUDE_DIRS})
target_link_libraries(logjammer PUBLIC ajantv2 ${TARGET_LINK_LIBS})

if (AJA_INSTALL_SOURCES)
	install(FILES ${LOGJAMMER_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/logjammer)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/logjammer)
endif()

install(TARGETS logjammer
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (AJA_CODE_SIGN)
    aja_code_sign(logjammer)
endif()

=== ajaapps/crossplatform/logreader/CMakeLists.txt ===
project(logreader)

set(LOGREADER_TARGET_INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${AJA_LIBRARIES_ROOT}
	${AJA_LIB_NTV2_ROOT}/includes)

set(LOGREADER_SOURCES main.cpp)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(LOGREADER_TARGET_SOURCES
	${LOGREADER_SOURCES})

add_executable(logreader ${LOGREADER_TARGET_SOURCES})
add_dependencies(logreader ajantv2)
target_include_directories(logreader PUBLIC ${LOGREADER_TARGET_INCLUDE_DIRS})
target_link_libraries(logreader PUBLIC ajantv2 ${TARGET_LINK_LIBS})

if (AJA_INSTALL_SOURCES)
	install(FILES ${LOGREADER_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/logreader)
endif()

if (AJA_INSTALL_SOURCES)
	install(FILES ${LOGREADER_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/logreader)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/logreader)
endif()

install(TARGETS logreader
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (AJA_CODE_SIGN)
    aja_code_sign(logreader)
endif()

=== ajaapps/crossplatform/ntv2firmwareinstaller/CMakeLists.txt ===
project(ntv2firmwareinstaller)

set(DEMO_APPS_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/../demoapps)

set(TARGET_INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${AJA_LIBRARIES_ROOT}
	${AJA_LIB_NTV2_ROOT}/includes
	${DEMO_APPS_ROOT}
	${AJA_LIB_NTV2_ROOT}/utilityfiles/private
	${AJA_LIB_NTV2_ROOT}/utilityfiles/public)

set(DEMO_APPS_HEADERS
	${DEMO_APPS_ROOT}/ntv2democommon.h)
set(DEMO_APPS_SOURCES
	${DEMO_APPS_ROOT}/ntv2democommon.cpp)
set(AJA_NTV2_UTILITY_PUBLIC_SOURCES
	${AJA_LIB_NTV2_ROOT}/utilityfiles/public/ntv2firmwareinstallerthread.h
	${AJA_LIB_NTV2_ROOT}/utilityfiles/public/ntv2firmwareinstallerthread.cpp)
set(NTV2FIRMWAREINSTALLER_SOURCES
	main.cpp)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(TARGET_SOURCES
	${DEMO_APPS_HEADERS}
	${DEMO_APPS_SOURCES}
	${AJA_NTV2_UTILITY_PUBLIC_SOURCES}
	${NTV2FIRMWAREINSTALLER_SOURCES})

add_executable(ntv2firmwareinstaller ${TARGET_SOURCES})
add_dependencies(ntv2firmwareinstaller ajantv2)
target_include_directories(ntv2firmwareinstaller PUBLIC ${TARGET_INCLUDE_DIRS})
target_link_libraries(ntv2firmwareinstaller PUBLIC ajantv2 ${TARGET_LINK_LIBS})

if (AJA_INSTALL_SOURCES)
	install(FILES ${DEMO_APPS_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/demoapps)
	install(FILES ${DEMO_APPS_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/demoapps)
	install(FILES ${AJA_NTV2_UTILITY_PUBLIC_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajalibraries/ajantv2/utilityfiles/public)
	install(FILES ${NTV2FIRMWAREINSTALLER_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/ntv2firmwareinstaller)
	install(FILES ${NTV2FIRMWAREINSTALLER_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/ntv2firmwareinstaller)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/ntv2firmwareinstaller)
endif()

install(TARGETS ntv2firmwareinstaller
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (AJA_CODE_SIGN)
    aja_code_sign(ntv2firmwareinstaller)
endif()

=== ajaapps/crossplatform/ntv2thermo/CMakeLists.txt ===
project(ntv2thermo)

set(TARGET_INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${AJA_LIBRARIES_ROOT}
	${AJA_LIB_NTV2_ROOT}/includes)

set(NTV2THERMO_SOURCES main.cpp)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(TARGET_SOURCES
	${NTV2THERMO_SOURCES})

add_executable(ntv2thermo ${TARGET_SOURCES})
add_dependencies(ntv2thermo ajantv2)
target_include_directories(ntv2thermo PUBLIC ${TARGET_INCLUDE_DIRS})
target_link_libraries(ntv2thermo PUBLIC ajantv2 ${TARGET_LINK_LIBS})

if (AJA_INSTALL_SOURCES)
	install(FILES ${NTV2THERMO_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/ntv2thermo)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/ntv2thermo)
endif()

install(TARGETS ntv2thermo
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (AJA_CODE_SIGN)
    aja_code_sign(ntv2thermo)
endif()

=== ajaapps/crossplatform/pciwhacker/CMakeLists.txt ===
project(pciwhacker)

set(DEMO_APPS_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/../demoapps)

set(TARGET_INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${AJA_LIBRARIES_ROOT}
	${AJA_LIB_NTV2_ROOT}/includes
    ${DEMO_APPS_ROOT})

set(DEMO_APPS_SOURCES
	${DEMO_APPS_ROOT}/ntv2democommon.cpp)
set(DEMO_APPS_HEADERS
	${DEMO_APPS_ROOT}/ntv2democommon.h)

set(PCIWHACKER_SOURCES
    main.cpp)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(TARGET_SOURCES
	${DEMO_APPS_HEADERS}
	${DEMO_APPS_SOURCES}
	${PCIWHACKER_SOURCES})

add_executable(pciwhacker ${TARGET_SOURCES})
add_dependencies(pciwhacker ajantv2)
target_include_directories(pciwhacker PUBLIC ${TARGET_INCLUDE_DIRS})
target_link_libraries(pciwhacker PUBLIC ajantv2 ${TARGET_LINK_LIBS})

if (AJA_INSTALL_SOURCES)
	install(FILES ${DEMO_APPS_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/demoapps)
	install(FILES ${DEMO_APPS_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/demoapps)
	install(FILES ${PCIWHACKER_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/pciwhacker)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/ajaapps/crossplatform/pciwhacker)
endif()

install(TARGETS pciwhacker
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (AJA_CODE_SIGN)
    aja_code_sign(pciwhacker)
endif()

=== debian/changelog ===
ntv2-dmo (16.2.5-dmo1) unstable; urgency=medium

  * Remove bugfix from upstream version. More eassy to manage.
  * Only build for amd64

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 05 Sep 2022 09:10:07 +0200

ntv2-dmo (16.2-bugfix5-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 01 Sep 2022 16:59:39 +0200

=== debian/control ===
Source: ntv2-dmo
Section: libdevel
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/aja-video/ntv2
Rules-Requires-Root: no
Standards-Version: 4.6.1
Build-Depends: debhelper-compat (= 13), cmake, ninja-build

Package: libajantv2-dev
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AJA NTV2 SDK
 NTV2 SDK for AJA PCI cards.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DAJA_BUILD_APPS=OFF \
	-DAJA_BUILD_OPENSOURCE=ON

#	exit 1

override_dh_clean:
	dh_clean ajadriver/mac/README.md ajadriver/win/README.md

override_dh_auto_test:

=== debian/watch ===
version=4

https://github.com/aja-video/ntv2/tags \
(?:.*?/)?v?(\d[\d.]*)-bugfix?(\d[\d.]*)@ARCHIVE_EXT@
